﻿using System;

/// @author  Vesa Lappalainen, Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Bonus 3. Pienet ja isot merkit.
/// </summary>
public class B4PienetIsoksi
{
    /// <summary>
    /// Pääohjelmassa näytetään ensin,
    /// millä aliohjelmalla merkit
    /// saadaan muutettua isoksi.
    /// Sitten pyydetään käyttäjältä merkki,
    /// ja tulostetaan true/false sen mukaan
    /// tulkitaanko se isoksi vaiko eikö.
    /// </summary>
    /// <param name="args">Ei käytössä.</param>
    public static void Main(string[] args)
    {
        char pienena = 'a';
        char isona = Char.ToUpper(pienena);
        Console.WriteLine(pienena + " => " + isona); // a => A
        pienena = 't';
        isona = Char.ToUpper(pienena);
        Console.WriteLine(pienena + " => " + isona); // t => T    }

        // Huomaa, että jos merkki ei ole suuraakkonen 
        // tai merkki on jo valmiiksi suuraakkonen, niin
        // ToUpper()-metodi palauttaa saman merkin.
        char testi = Char.ToUpper('!');
        Console.WriteLine(testi);
        testi = Char.ToUpper('B');
        Console.WriteLine(testi);
    }


    /// <summary>
    /// Onko annetun merkkijonon ensimmäinen
    /// kirjain pieni vai iso. Jos 1. merkkiä ei ole tai se
    /// on muu kuin kirjain, palautetaan aina "pieni"
    /// </summary>
    /// <param name="jono">Tarkasteltava merkkijono.</param>
    /// <returns>Onko ensimmäinen merkki iso vai pieni.</returns>
    /// <example>
    /// <pre name="test">
    /// IsoVaiPieni("kissa") === "pieni" 
    /// IsoVaiPieni("KisSa") === "iso"
    /// IsoVaiPieni("") === "pieni"
    /// IsoVaiPieni("12") === "pieni"
    /// </pre>
    /// </example>
    public static string IsoVaiPieni(string jono)
    {
        if (jono.Length == 0) return "pieni";
        if (char.IsUpper(jono[0])) return "iso";
        else return "pieni";
    }

}
