﻿using System;

/// @author  Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Demo 4, tehtävä 3.
/// Pidempi merkkijono kahdesta.
/// </summary>
public class T3_PidempiJono
{
    /// <summary>
    /// Pääohjelmassa pyydetään käyttäjän syöte ja tulostetaan pidempi jono.
    /// </summary>
    public static void Main(string[] args)
    {
        Console.Write("Anna 1. jono > ");
        string jono1 = Console.ReadLine();
        Console.Write("Anna 2. jono > ");
        string jono2 = Console.ReadLine();
        string pidempi = PidempiMerkkijono(jono1, jono2);
        Console.WriteLine($"\"{pidempi}\" on pidempi jono");
    }


    /// <summary>
    /// Aliohjelmassa verrataan kumpi annetuista merkkijonoista on pidempi,
    /// ja palauttaa pidemmän sanan. Sanojen ollessa yhtä pitkiä
    /// palautetaan ensimmäinen sana.
    /// </summary>
    /// <param name="jono1">Ensimmäinen verrattava jono.</param>
    /// <param name="jono2">Toinen verrattava jono.</param>
    /// <returns>Pidempi annetuista jonoista.</returns>
    /// <example>
    /// <pre name="test">
    /// PidempiMerkkijono("Eka jono", "toka") === "Eka jono";
    /// PidempiMerkkijono("Eka", "Toka") === "Toka";
    /// PidempiMerkkijono("Eka", "Tok") === "Eka";
    /// PidempiMerkkijono("", "Toka") === "Toka";
    /// PidempiMerkkijono("", "") === "";
    /// </pre>
    /// </example>
    public static string PidempiMerkkijono(string jono1, string jono2)
    {
        if (jono1.Length >= jono2.Length) return jono1;
        else return jono2; 

        // TAI
        // string pidempi = ekaJono;
        // if (tokaJono.Length > ekaJono.Length) pidempi = tokaJono;
        // // if (tokaJono.Length > pidempi.Length) pidempi = tokaJono;
        // return pidempi;
        
        // TAI käyttäen ?: -operaattoria (ei käsitellä tarkemmin tällä kurssilla 
        // return jono1.Length >= jono2.Length ? jono1 : jono2;

    }
}
