﻿using System;

/// @author  Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Demo 4, tehtävä 6.
/// Ohjelmassa harjoitellaan merkkijonojen
/// käsittelyä ja funktioiden tekemistä.
/// </summary>
public class SukunimiEtunimi
{
    /// <summary>
    /// Kysytään käyttäjältä nimi, sitten tulostetaan
    /// sukunimi ja etunimi.
    /// </summary>
    public static void Main()
    {
        Console.Write($"Anna nimesi muodossa sukunimi etunimi > ");
        string kokonimi = Console.ReadLine();
        string etunimi = PoistaEkaSana(kokonimi);
        string sukunimi = VainEkaSana(kokonimi);
        Console.WriteLine($"Etunimesi on siis {etunimi} ja sukunimesi {sukunimi}");
    }


    /// <summary>
    /// Palauttaa annetusta merkkijonosta ensimmäisen välilyönnin jälkeisen osan.
    /// Jos merkkijonossa ei ole välilyöntiä, palautetaan tyhjä merkkijono.
    /// </summary>
    /// <param name="kokonimi">Tutkittava merkkijono.</param>
    /// <returns>Merkkijono, josta on poistettu
    /// ensimmäinen välilyönti ja sitä edeltävä osa.</returns>
    /// <example>
    /// <pre name="test">
    /// PoistaEkaSana("Lakanen Antti-Jussi") === "Antti-Jussi";
    /// PoistaEkaSana("Lakanen Antti Jussi") === "Antti Jussi";
    /// PoistaEkaSana("Hallinen-Mielikäinen Irma-Uolevi") === "Irma-Uolevi";
    /// PoistaEkaSana("Äk Åke") === "Åke";
    /// PoistaEkaSana("Aisha") === "";
    /// </pre>
    /// </example>
    public static string PoistaEkaSana(string kokonimi)
    {
        int valilyonninPaikka = kokonimi.IndexOf(' ');
        if (valilyonninPaikka < 0) return "";
        return kokonimi.Substring(valilyonninPaikka + 1);
    }

    /// <summary>
    /// Aliohjelma palauttaa annetusta merkkijonosta
    /// ensimmäistä välilyöntiä edeltävän osan.
    /// Jos jonossa ei ole välilyöntiä, alkuperäinen
    /// merkkijono.
    /// </summary>
    /// <param name="kokonimi">Tutkittava merkkijono.</param>
    /// <returns>Merkkijono, josta on poistettu
    /// kaikki muu paitsi välilyöntiä edeltävä osa.</returns>
    /// <example>
    /// <pre name="test">
    /// VainEkaSana("Lakanen Antti-Jussi") === "Lakanen";
    /// VainEkaSana("Lakanen Antti Jussi") === "Lakanen";
    /// VainEkaSana("Hallinen-Mielikäinen Irma-Uolevi") === "Hallinen-Mielikäinen";
    /// VainEkaSana("Äk Åke") === "Äk";
    /// VainEkaSana("Aisha") === "Aisha";
    /// VainEkaSana("") === "";
    /// </pre>
    /// </example>
    public static string VainEkaSana(string kokonimi)
    {
        int valilyonninPaikka = kokonimi.IndexOf(' ');
        if (valilyonninPaikka < 0) return kokonimi;
        // Esimerkiksi:
        //        . <-- pituus == 7, siis paikat 0-6 otetaan mukaan alijonoon.
        // 0123456789012345678
        // Lakanen Antti-Jussi

        return kokonimi.Substring(0, valilyonninPaikka);

        // Tapa 2:
        // string[] jononPalat = kokonimi.Split(' ');
        // return jononPalat[0];

        // Tapa 3:
        // return kokonimi.Split(' ')[0];

        // Tapa 4:
        // string sukunimi = kokonimi.Split(' ')[0];
        // return sukunimi;
        
        // Tapa 5 (käyttämällä ns. range indexer):
        // string ekaSana = kokonimi[..valilyonninPaikka];
    }
}
